diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/wifi/model/wifi-phy.cc ns-3.35/src/wifi/model/wifi-phy.cc
--- ns-3.34/src/wifi/model/wifi-phy.cc	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/wifi/model/wifi-phy.cc	2021-10-01 13:26:48.000000000 -0700
@@ -505,7 +505,7 @@
                      "Trace source indicating a packet "
                      "has begun transmitting over the channel medium",
                      MakeTraceSourceAccessor (&WifiPhy::m_phyTxBeginTrace),
-                     "ns3::Packet::TracedCallback")
+                     "ns3::WifiPhy::PhyTxBeginTracedCallback")
     .AddTraceSource ("PhyTxPsduBegin",
                      "Trace source indicating a PSDU "
                      "has begun transmitting over the channel medium",
@@ -526,7 +526,7 @@
                      "has begun being received from the channel medium "
                      "by the device",
                      MakeTraceSourceAccessor (&WifiPhy::m_phyRxBeginTrace),
-                     "ns3::Packet::TracedCallback")
+                     "ns3::WifiPhy::PhyRxBeginTracedCallback")
     .AddTraceSource ("PhyRxPayloadBegin",
                      "Trace source indicating the reception of the "
                      "payload of a PPDU has begun",
@@ -1636,11 +1636,14 @@
 void
 WifiPhy::NotifyTxBegin (WifiConstPsduMap psdus, double txPowerW)
 {
-  for (auto const& psdu : psdus)
+  if (!m_phyTxBeginTrace.IsEmpty ())
     {
-      for (auto& mpdu : *PeekPointer (psdu.second))
+      for (auto const& psdu : psdus)
         {
-          m_phyTxBeginTrace (mpdu->GetProtocolDataUnit (), txPowerW);
+          for (auto& mpdu : *PeekPointer (psdu.second))
+            {
+              m_phyTxBeginTrace (mpdu->GetProtocolDataUnit (), txPowerW);
+            }
         }
     }
 }
@@ -1648,11 +1651,14 @@
 void
 WifiPhy::NotifyTxEnd (WifiConstPsduMap psdus)
 {
-  for (auto const& psdu : psdus)
+  if (!m_phyTxEndTrace.IsEmpty ())
     {
-      for (auto& mpdu : *PeekPointer (psdu.second))
+      for (auto const& psdu : psdus)
         {
-          m_phyTxEndTrace (mpdu->GetProtocolDataUnit ());
+          for (auto& mpdu : *PeekPointer (psdu.second))
+            {
+              m_phyTxEndTrace (mpdu->GetProtocolDataUnit ());
+            }
         }
     }
 }
@@ -1660,16 +1666,19 @@
 void
 WifiPhy::NotifyTxDrop (Ptr<const WifiPsdu> psdu)
 {
-  for (auto& mpdu : *PeekPointer (psdu))
+  if (!m_phyTxDropTrace.IsEmpty ())
     {
-      m_phyTxDropTrace (mpdu->GetProtocolDataUnit ());
+      for (auto& mpdu : *PeekPointer (psdu))
+        {
+          m_phyTxDropTrace (mpdu->GetProtocolDataUnit ());
+        }
     }
 }
 
 void
-WifiPhy::NotifyRxBegin (Ptr<const WifiPsdu> psdu, RxPowerWattPerChannelBand rxPowersW)
+WifiPhy::NotifyRxBegin (Ptr<const WifiPsdu> psdu, const RxPowerWattPerChannelBand& rxPowersW)
 {
-  if (psdu)
+  if (psdu && !m_phyRxBeginTrace.IsEmpty ())
     {
       for (auto& mpdu : *PeekPointer (psdu))
         {
@@ -1681,7 +1690,7 @@
 void
 WifiPhy::NotifyRxEnd (Ptr<const WifiPsdu> psdu)
 {
-  if (psdu)
+  if (psdu && !m_phyRxEndTrace.IsEmpty ())
     {
       for (auto& mpdu : *PeekPointer (psdu))
         {
@@ -1693,7 +1702,7 @@
 void
 WifiPhy::NotifyRxDrop (Ptr<const WifiPsdu> psdu, WifiPhyRxfailureReason reason)
 {
-  if (psdu)
+  if (psdu && !m_phyRxDropTrace.IsEmpty ())
     {
       for (auto& mpdu : *PeekPointer (psdu))
         {
@@ -1714,22 +1723,28 @@
       aMpdu.mpduRefNumber = ++m_rxMpduReferenceNumber;
       size_t nMpdus = psdu->GetNMpdus ();
       NS_ASSERT_MSG (statusPerMpdu.size () == nMpdus, "Should have one reception status per MPDU");
-      aMpdu.type = (psdu->IsSingle ()) ? SINGLE_MPDU : FIRST_MPDU_IN_AGGREGATE;
-      for (size_t i = 0; i < nMpdus;)
+      if (!m_phyMonitorSniffRxTrace.IsEmpty ())
         {
-          if (statusPerMpdu.at (i)) //packet received without error, hand over to sniffer
+          aMpdu.type = (psdu->IsSingle ()) ? SINGLE_MPDU : FIRST_MPDU_IN_AGGREGATE;
+          for (size_t i = 0; i < nMpdus;)
             {
-              m_phyMonitorSniffRxTrace (psdu->GetAmpduSubframe (i), channelFreqMhz, txVector, aMpdu, signalNoise, staId);
+              if (statusPerMpdu.at (i)) //packet received without error, hand over to sniffer
+                {
+                  m_phyMonitorSniffRxTrace (psdu->GetAmpduSubframe (i), channelFreqMhz, txVector, aMpdu, signalNoise, staId);
+                }
+              ++i;
+              aMpdu.type = (i == (nMpdus - 1)) ? LAST_MPDU_IN_AGGREGATE : MIDDLE_MPDU_IN_AGGREGATE;
             }
-          ++i;
-          aMpdu.type = (i == (nMpdus - 1)) ? LAST_MPDU_IN_AGGREGATE : MIDDLE_MPDU_IN_AGGREGATE;
         }
     }
   else
     {
-      aMpdu.type = NORMAL_MPDU;
       NS_ASSERT_MSG (statusPerMpdu.size () == 1, "Should have one reception status for normal MPDU");
-      m_phyMonitorSniffRxTrace (psdu->GetPacket (), channelFreqMhz, txVector, aMpdu, signalNoise, staId);
+      if (!m_phyMonitorSniffRxTrace.IsEmpty ())
+        {
+          aMpdu.type = NORMAL_MPDU;
+          m_phyMonitorSniffRxTrace (psdu->GetPacket (), channelFreqMhz, txVector, aMpdu, signalNoise, staId);
+        }
     }
 }
 
@@ -1742,19 +1757,25 @@
       //Expand A-MPDU
       NS_ASSERT_MSG (txVector.IsAggregation (), "TxVector with aggregate flag expected here according to PSDU");
       aMpdu.mpduRefNumber = ++m_rxMpduReferenceNumber;
-      size_t nMpdus = psdu->GetNMpdus ();
-      aMpdu.type = (psdu->IsSingle ()) ? SINGLE_MPDU: FIRST_MPDU_IN_AGGREGATE;
-      for (size_t i = 0; i < nMpdus;)
+      if (!m_phyMonitorSniffTxTrace.IsEmpty ())
         {
-          m_phyMonitorSniffTxTrace (psdu->GetAmpduSubframe (i), channelFreqMhz, txVector, aMpdu, staId);
-          ++i;
-          aMpdu.type = (i == (nMpdus - 1)) ? LAST_MPDU_IN_AGGREGATE : MIDDLE_MPDU_IN_AGGREGATE;
+          size_t nMpdus = psdu->GetNMpdus ();
+          aMpdu.type = (psdu->IsSingle ()) ? SINGLE_MPDU: FIRST_MPDU_IN_AGGREGATE;
+          for (size_t i = 0; i < nMpdus;)
+            {
+              m_phyMonitorSniffTxTrace (psdu->GetAmpduSubframe (i), channelFreqMhz, txVector, aMpdu, staId);
+              ++i;
+              aMpdu.type = (i == (nMpdus - 1)) ? LAST_MPDU_IN_AGGREGATE : MIDDLE_MPDU_IN_AGGREGATE;
+            }
         }
     }
   else
     {
-      aMpdu.type = NORMAL_MPDU;
-      m_phyMonitorSniffTxTrace (psdu->GetPacket (), channelFreqMhz, txVector, aMpdu, staId);
+      if (!m_phyMonitorSniffTxTrace.IsEmpty ())
+        {
+          aMpdu.type = NORMAL_MPDU;
+          m_phyMonitorSniffTxTrace (psdu->GetPacket (), channelFreqMhz, txVector, aMpdu, staId);
+        }
     }
 }
 
@@ -1820,7 +1841,7 @@
     {
       AbortCurrentReception (RECEPTION_ABORTED_BY_TX);
       //that packet will be noise _after_ the transmission.
-      MaybeCcaBusyDuration (GetMeasurementChannelWidth (m_currentEvent != 0 ? m_currentEvent->GetPpdu () : nullptr));
+      SwitchMaybeToCcaBusy (GetMeasurementChannelWidth (m_currentEvent != 0 ? m_currentEvent->GetPpdu () : nullptr));
     }
 
   for (auto & it : m_phyEntities)
@@ -1850,7 +1871,10 @@
 
   double txPowerW = DbmToW (GetTxPowerForTransmission (ppdu) + GetTxGain ());
   NotifyTxBegin (psdus, txPowerW);
-  m_phyTxPsduBeginTrace (psdus, txVector, txPowerW);
+  if (!m_phyTxPsduBeginTrace.IsEmpty ())
+    {
+      m_phyTxPsduBeginTrace (psdus, txVector, txPowerW);
+    }
   for (auto const& psdu : psdus)
     {
       NotifyMonitorSniffTx (psdu.second, GetFrequency (), txVector, psdu.first);
@@ -1891,7 +1915,7 @@
 }
 
 void
-WifiPhy::StartReceivePreamble (Ptr<WifiPpdu> ppdu, RxPowerWattPerChannelBand rxPowersW, Time rxDuration)
+WifiPhy::StartReceivePreamble (Ptr<WifiPpdu> ppdu, RxPowerWattPerChannelBand& rxPowersW, Time rxDuration)
 {
   WifiModulationClass modulation = ppdu->GetTxVector ().GetModulationClass ();
   auto it = m_phyEntities.find (modulation);
@@ -1905,25 +1929,12 @@
       NS_LOG_DEBUG ("Unsupported modulation received (" << modulation << "), consider as noise");
       if (ppdu->GetTxDuration () > m_state->GetDelayUntilIdle ())
         {
-          MaybeCcaBusyDuration (GetMeasurementChannelWidth (nullptr));
+          m_interference.Add (ppdu, ppdu->GetTxVector (), rxDuration, rxPowersW);
+          SwitchMaybeToCcaBusy (GetMeasurementChannelWidth (nullptr));
         }
     }
 }
 
-void
-WifiPhy::MaybeCcaBusyDuration (uint16_t channelWidth)
-{
-  //We are here because we have received the first bit of a packet and we are
-  //not going to be able to synchronize on it
-  //In this model, CCA becomes busy when the aggregation of all signals as
-  //tracked by the InterferenceHelper class is higher than the CcaBusyThreshold
-  Time delayUntilCcaEnd = m_interference.GetEnergyDuration (m_ccaEdThresholdW, GetPrimaryBand (channelWidth));
-  if (!delayUntilCcaEnd.IsZero ())
-    {
-      m_state->SwitchMaybeToCcaBusy (delayUntilCcaEnd);
-    }
-}
-
 WifiSpectrumBand
 WifiPhy::ConvertHeRuSubcarriers (uint16_t bandWidth, uint16_t guardBandwidth,
                                  HeRu::SubcarrierRange range, uint8_t bandIndex) const
@@ -1951,7 +1962,7 @@
   m_interference.NotifyRxEnd (Simulator::Now ());
   m_currentEvent = 0;
   m_currentPreambleEvents.clear ();
-  MaybeCcaBusyDuration (GetMeasurementChannelWidth (event->GetPpdu ()));
+  SwitchMaybeToCcaBusy (GetMeasurementChannelWidth (event->GetPpdu ()));
 }
 
 void
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/wifi/model/wifi-phy-common.cc ns-3.35/src/wifi/model/wifi-phy-common.cc
--- ns-3.34/src/wifi/model/wifi-phy-common.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.35/src/wifi/model/wifi-phy-common.cc	2021-10-01 13:26:48.000000000 -0700
@@ -0,0 +1,175 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2021
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Sébastien Deronne <sebastien.deronne@gmail.com>
+ */
+
+#include "wifi-phy-common.h"
+#include "wifi-mode.h"
+#include "wifi-net-device.h"
+#include "ns3/ht-configuration.h"
+#include "ns3/he-configuration.h"
+
+namespace ns3 {
+
+uint16_t
+ConvertGuardIntervalToNanoSeconds (WifiMode mode, const Ptr<WifiNetDevice> device)
+{
+  uint16_t gi = 800;
+  if (mode.GetModulationClass () == WIFI_MOD_CLASS_HE)
+    {
+      Ptr<HeConfiguration> heConfiguration = device->GetHeConfiguration ();
+      NS_ASSERT (heConfiguration); //If HE modulation is used, we should have a HE configuration attached
+      gi = static_cast<uint16_t> (heConfiguration->GetGuardInterval ().GetNanoSeconds ());
+    }
+  else if (mode.GetModulationClass () == WIFI_MOD_CLASS_HT || mode.GetModulationClass () == WIFI_MOD_CLASS_VHT)
+    {
+      Ptr<HtConfiguration> htConfiguration = device->GetHtConfiguration ();
+      NS_ASSERT (htConfiguration); //If HT/VHT modulation is used, we should have a HT configuration attached
+      gi = htConfiguration->GetShortGuardIntervalSupported () ? 400 : 800;
+    }
+  return gi;
+}
+
+uint16_t
+ConvertGuardIntervalToNanoSeconds (WifiMode mode, bool htShortGuardInterval, Time heGuardInterval)
+{
+  uint16_t gi;
+  if (mode.GetModulationClass () == WIFI_MOD_CLASS_HE)
+    {
+      gi = static_cast<uint16_t> (heGuardInterval.GetNanoSeconds ());
+    }
+  else if (mode.GetModulationClass () == WIFI_MOD_CLASS_HT || mode.GetModulationClass () == WIFI_MOD_CLASS_VHT)
+    {
+      gi = htShortGuardInterval ? 400 : 800;
+    }
+  else
+    {
+      gi = 800;
+    }
+  return gi;
+}
+
+uint16_t
+GetChannelWidthForTransmission (WifiMode mode, uint16_t maxSupportedChannelWidth)
+{
+  WifiModulationClass modulationClass = mode.GetModulationClass ();
+  if (maxSupportedChannelWidth > 20
+      && (modulationClass == WifiModulationClass::WIFI_MOD_CLASS_OFDM // all non-HT OFDM control and management frames
+          || modulationClass == WifiModulationClass::WIFI_MOD_CLASS_ERP_OFDM)) // special case of beacons at 2.4 GHz
+    {
+      return 20;
+    }
+  //at 2.4 GHz basic rate can be non-ERP DSSS
+  if (modulationClass == WifiModulationClass::WIFI_MOD_CLASS_DSSS
+      || modulationClass == WifiModulationClass::WIFI_MOD_CLASS_HR_DSSS)
+    {
+      return 22;
+    }
+  return maxSupportedChannelWidth;
+}
+
+WifiPreamble
+GetPreambleForTransmission (WifiModulationClass modulation, bool useShortPreamble)
+{
+  if (modulation == WIFI_MOD_CLASS_HE)
+    {
+      return WIFI_PREAMBLE_HE_SU;
+    }
+  else if (modulation == WIFI_MOD_CLASS_VHT)
+    {
+      return WIFI_PREAMBLE_VHT_SU;
+    }
+  else if (modulation == WIFI_MOD_CLASS_HT)
+    {
+      return WIFI_PREAMBLE_HT_MF; // HT_GF has been removed
+    }
+  else if (modulation == WIFI_MOD_CLASS_HR_DSSS && useShortPreamble) //ERP_DSSS is modeled through HR_DSSS (since same preamble and modulation)
+    {
+      return WIFI_PREAMBLE_SHORT;
+    }
+  else
+    {
+      return WIFI_PREAMBLE_LONG;
+    }
+}
+
+bool
+IsAllowedControlAnswerModulationClass (WifiModulationClass modClassReq, WifiModulationClass modClassAnswer)
+{
+  switch (modClassReq)
+    {
+    case WIFI_MOD_CLASS_DSSS:
+      return (modClassAnswer == WIFI_MOD_CLASS_DSSS);
+    case WIFI_MOD_CLASS_HR_DSSS:
+      return (modClassAnswer == WIFI_MOD_CLASS_DSSS || modClassAnswer == WIFI_MOD_CLASS_HR_DSSS);
+    case WIFI_MOD_CLASS_ERP_OFDM:
+      return (modClassAnswer == WIFI_MOD_CLASS_DSSS || modClassAnswer == WIFI_MOD_CLASS_HR_DSSS || modClassAnswer == WIFI_MOD_CLASS_ERP_OFDM);
+    case WIFI_MOD_CLASS_OFDM:
+      return (modClassAnswer == WIFI_MOD_CLASS_OFDM);
+    case WIFI_MOD_CLASS_HT:
+    case WIFI_MOD_CLASS_VHT:
+    case WIFI_MOD_CLASS_HE:
+      return true;
+    default:
+      NS_FATAL_ERROR ("Modulation class not defined");
+      return false;
+    }
+}
+
+Time
+GetPpduMaxTime (WifiPreamble preamble)
+{
+  Time duration;
+
+  switch (preamble)
+    {
+      case WIFI_PREAMBLE_HT_MF:
+      case WIFI_PREAMBLE_VHT_SU:
+      case WIFI_PREAMBLE_VHT_MU:
+      case WIFI_PREAMBLE_HE_SU:
+      case WIFI_PREAMBLE_HE_ER_SU:
+      case WIFI_PREAMBLE_HE_MU:
+      case WIFI_PREAMBLE_HE_TB:
+        duration = MicroSeconds (5484);
+        break;
+      default:
+        duration = MicroSeconds (0);
+        break;
+    }
+  return duration;
+}
+
+bool
+IsMu (WifiPreamble preamble)
+{
+  return (IsDlMu (preamble) || IsUlMu (preamble));
+}
+
+bool
+IsDlMu (WifiPreamble preamble)
+{
+  return (preamble == WIFI_PREAMBLE_HE_MU);
+}
+
+bool
+IsUlMu (WifiPreamble preamble)
+{
+  return (preamble == WIFI_PREAMBLE_HE_TB);
+}
+
+} //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/wifi/model/wifi-phy-common.h ns-3.35/src/wifi/model/wifi-phy-common.h
--- ns-3.34/src/wifi/model/wifi-phy-common.h	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/wifi/model/wifi-phy-common.h	2021-10-01 13:26:48.000000000 -0700
@@ -25,6 +25,7 @@
 
 #include <ostream>
 #include "ns3/fatal-error.h"
+#include "ns3/ptr.h"
 
 /**
  * \file
@@ -39,6 +40,10 @@
 
 namespace ns3 {
 
+class WifiNetDevice;
+class WifiMode;
+class Time;
+
 /**
  * These constants define the various convolutional coding rates
  * used for the OFDM transmission modes in the IEEE 802.11
@@ -328,6 +333,95 @@
     }
 }
 
+/**
+ * Convert the guard interval to nanoseconds based on the WifiMode.
+ *
+ * \param mode the WifiMode
+ * \param device pointer to the WifiNetDevice object
+ *
+ * \return the guard interval duration in nanoseconds
+ */
+uint16_t ConvertGuardIntervalToNanoSeconds (WifiMode mode, const Ptr<WifiNetDevice> device);
+
+/**
+ * Convert the guard interval to nanoseconds based on the WifiMode.
+ *
+ * \param mode the WifiMode
+ * \param htShortGuardInterval whether HT/VHT short guard interval is enabled
+ * \param heGuardInterval the HE guard interval duration
+ *
+ * \return the guard interval duration in nanoseconds
+ */
+uint16_t ConvertGuardIntervalToNanoSeconds (WifiMode mode, bool htShortGuardInterval, Time heGuardInterval);
+
+/**
+ * Return the preamble to be used for the transmission.
+ *
+ * \param modulation the modulation selected for the transmission
+ * \param useShortPreamble whether short preamble should be used
+ *
+ * \return the preamble to be used for the transmission
+ */
+WifiPreamble GetPreambleForTransmission (WifiModulationClass modulation, bool useShortPreamble);
+
+/**
+ * Return the channel width that corresponds to the selected mode (instead of
+ * letting the PHY's default channel width). This is especially useful when using
+ * non-HT modes with HT/VHT/HE capable stations (with default width above 20 MHz).
+ *
+ * \param mode selected WifiMode
+ * \param maxSupportedChannelWidth maximum channel width supported by the PHY layer
+ * \return channel width adapted to the selected mode
+ */
+uint16_t GetChannelWidthForTransmission (WifiMode mode, uint16_t maxSupportedChannelWidth);
+
+/**
+ * Return whether the modulation class of the selected mode for the
+ * control answer frame is allowed.
+ *
+ * \param modClassReq modulation class of the request frame
+ * \param modClassAnswer modulation class of the answer frame
+ *
+ * \return true if the modulation class of the selected mode for the
+ * control answer frame is allowed, false otherwise
+ */
+bool IsAllowedControlAnswerModulationClass (WifiModulationClass modClassReq, WifiModulationClass modClassAnswer);
+
+/**
+ * Get the maximum PPDU duration (see Section 10.14 of 802.11-2016) for
+ * the PHY layers defining the aPPDUMaxTime characteristic (HT, VHT and HE).
+ * Return zero otherwise.
+ *
+ * \param preamble the preamble type
+ *
+ * \return the maximum PPDU duration, if defined, and zero otherwise
+ */
+Time GetPpduMaxTime (WifiPreamble preamble);
+
+/**
+ * Return true if a preamble corresponds to a multi-user transmission.
+ *
+ * \param preamble the preamble
+ * \return true if the provided preamble corresponds to a multi-user transmission
+ */
+bool IsMu (WifiPreamble preamble);
+
+/**
+ * Return true if a preamble corresponds to a downlink multi-user transmission.
+ *
+ * \param preamble the preamble
+ * \return true if the provided preamble corresponds to a downlink multi-user transmission
+ */
+bool IsDlMu (WifiPreamble preamble);
+
+/**
+ * Return true if a preamble corresponds to a uplink multi-user transmission.
+ *
+ * \param preamble the preamble
+ * \return true if the provided preamble corresponds to a uplink multi-user transmission
+ */
+bool IsUlMu (WifiPreamble preamble);
+
 } //namespace ns3
 
 #endif /* WIFI_PHY_COMMON_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/wifi/model/wifi-phy.h ns-3.35/src/wifi/model/wifi-phy.h
--- ns-3.34/src/wifi/model/wifi-phy.h	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/wifi/model/wifi-phy.h	2021-10-01 13:26:48.000000000 -0700
@@ -105,7 +105,7 @@
    * \param rxPowersW the receive power in W per band
    * \param rxDuration the duration of the PPDU
    */
-  void StartReceivePreamble (Ptr<WifiPpdu> ppdu, RxPowerWattPerChannelBand rxPowersW, Time rxDuration);
+  void StartReceivePreamble (Ptr<WifiPpdu> ppdu, RxPowerWattPerChannelBand& rxPowersW, Time rxDuration);
 
   /**
    * Reset PHY at the end of the packet under reception after it has failed the PHY header.
@@ -570,7 +570,7 @@
    * \param psdu the PSDU being transmitted
    * \param rxPowersW the receive power per channel band in Watts
    */
-  void NotifyRxBegin (Ptr<const WifiPsdu> psdu, RxPowerWattPerChannelBand rxPowersW);
+  void NotifyRxBegin (Ptr<const WifiPsdu> psdu, const RxPowerWattPerChannelBand& rxPowersW);
   /**
    * Public method used to fire a PhyRxEnd trace.
    * Implemented for encapsulation purposes.
@@ -679,6 +679,14 @@
                                             uint16_t staId);
 
   /**
+   * TracedCallback signature for Phy transmit events.
+   *
+   * \param packet the packet being transmitted
+   * \param txPowerW the transmit power in Watts
+   */
+  typedef void (* PhyTxBeginTracedCallback)(Ptr<const Packet> packet, double txPowerW);
+
+  /**
    * TracedCallback signature for PSDU transmit events.
    *
    * \param psduMap the PSDU map being transmitted
@@ -688,6 +696,14 @@
   typedef void (* PsduTxBeginCallback)(WifiConstPsduMap psduMap, WifiTxVector txVector, double txPowerW);
 
   /**
+   * TracedCallback signature for PhyRxBegin trace source.
+   *
+   * \param packet the packet being received
+   * \param rxPowersW the receive power per channel band in Watts
+   */
+  typedef void (* PhyRxBeginTracedCallback) (Ptr<const Packet> packet, RxPowerWattPerChannelBand rxPowersW);
+
+  /**
    * TracedCallback signature for start of PSDU reception events.
    *
    * \param txVector the TXVECTOR decoded from the PHY header
@@ -1254,12 +1270,6 @@
   void AbortCurrentReception (WifiPhyRxfailureReason reason);
 
   /**
-   * Eventually switch to CCA busy
-   * \param channelWidth the channel width in MHz used for RSSI measurement
-   */
-  void MaybeCcaBusyDuration (uint16_t channelWidth);
-
-  /**
    * Get the PSDU addressed to that PHY in a PPDU (useful for MU PPDU).
    *
    * \param ppdu the PPDU to extract the PSDU from
@@ -1346,7 +1356,7 @@
    * ieee80211_input_monitor()
    *
    * \see class CallBackTraceSource
-   * \todo WifiTxVector and signalNoiseDbm should be be passed as
+   * \todo WifiTxVector and signalNoiseDbm should be passed as
    *       const references because of their sizes.
    */
   TracedCallback<Ptr<const Packet>, uint16_t /* frequency (MHz) */, WifiTxVector, MpduInfo, SignalNoiseDbm, uint16_t /* STA-ID*/> m_phyMonitorSniffRxTrace;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/wifi/model/wifi-phy-state-helper.cc ns-3.35/src/wifi/model/wifi-phy-state-helper.cc
--- ns-3.34/src/wifi/model/wifi-phy-state-helper.cc	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/wifi/model/wifi-phy-state-helper.cc	2021-10-01 13:26:48.000000000 -0700
@@ -358,9 +358,13 @@
 WifiPhyStateHelper::SwitchToTx (Time txDuration, WifiConstPsduMap psdus, double txPowerDbm, WifiTxVector txVector)
 {
   NS_LOG_FUNCTION (this << txDuration << psdus << txPowerDbm << txVector);
-  for (auto const& psdu : psdus)
+  if (!m_txTrace.IsEmpty ())
     {
-      m_txTrace (psdu.second->GetPacket (), txVector.GetMode (psdu.first), txVector.GetPreambleType (), txVector.GetTxPowerLevel ());
+      for (auto const& psdu : psdus)
+        {
+          m_txTrace (psdu.second->GetPacket (), txVector.GetMode (psdu.first),
+                     txVector.GetPreambleType (), txVector.GetTxPowerLevel ());
+        }
     }
   Time now = Simulator::Now ();
   switch (GetState ())
@@ -483,7 +487,11 @@
   NS_ASSERT (statusPerMpdu.size () != 0);
   NS_ASSERT (Abs (m_endRx - Simulator::Now ()) < MicroSeconds (1)); //1us corresponds to the maximum propagation delay (delay spread)
   //TODO: a better fix would be to call the function once all HE TB PPDUs are received
-  m_rxOkTrace (psdu->GetPacket (), rxSignalInfo.snr, txVector.GetMode (staId), txVector.GetPreambleType ());
+  if (!m_rxOkTrace.IsEmpty ())
+    {
+      m_rxOkTrace (psdu->GetPacket (), rxSignalInfo.snr, txVector.GetMode (staId),
+                   txVector.GetPreambleType ());
+    }
   NotifyRxEndOk ();
   DoSwitchFromRx ();
   if (!m_rxOkCallback.IsNull ())
@@ -498,7 +506,10 @@
   NS_LOG_FUNCTION (this << *psdu << snr);
   NS_ASSERT (Abs (m_endRx - Simulator::Now ()) < MicroSeconds (1)); //1us corresponds to the maximum propagation delay (delay spread)
   //TODO: a better fix would be to call the function once all HE TB PPDUs are received
-  m_rxErrorTrace (psdu->GetPacket (), snr);
+  if (!m_rxErrorTrace.IsEmpty ())
+    {
+      m_rxErrorTrace (psdu->GetPacket (), snr);
+    }
   NotifyRxEndError ();
   DoSwitchFromRx ();
   if (!m_rxErrorCallback.IsNull ())
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/wifi/model/wifi-remote-station-manager.cc ns-3.35/src/wifi/model/wifi-remote-station-manager.cc
--- ns-3.34/src/wifi/model/wifi-remote-station-manager.cc	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/wifi/model/wifi-remote-station-manager.cc	2021-10-01 13:26:48.000000000 -0700
@@ -493,6 +493,18 @@
 }
 
 uint16_t
+WifiRemoteStationManager::GetAssociationId (Mac48Address remoteAddress) const
+{
+  WifiRemoteStationState* state;
+  if (!remoteAddress.IsGroup ()
+      && (state = LookupState (remoteAddress))->m_state == WifiRemoteStationState::GOT_ASSOC_TX_OK)
+    {
+      return state->m_aid;
+    }
+  return SU_STA_ID;
+}
+
+uint16_t
 WifiRemoteStationManager::GetStaId (Mac48Address address, const WifiTxVector& txVector) const
 {
   NS_LOG_FUNCTION (this << address << txVector);
@@ -503,7 +515,7 @@
     {
       if (m_wifiMac->GetTypeOfStation () == AP)
         {
-          staId = StaticCast<ApWifiMac> (m_wifiMac)->GetAssociationId (address);
+          staId = GetAssociationId (address);
         }
       else if (m_wifiMac->GetTypeOfStation () == STA)
         {
@@ -1206,20 +1218,12 @@
 double
 WifiRemoteStationManager::GetMostRecentRssi (Mac48Address address) const
 {
-  double rssi = 0.0;
-  Time mostRecentUpdateTime = NanoSeconds (0);
-  for (const auto & station : m_stations)
-    {
-      if (station->m_state->m_address == address) //get most recent RSSI irrespective of TID
-        {
-          if (station->m_rssiAndUpdateTimePair.second >= mostRecentUpdateTime)
-            {
-              rssi = station->m_rssiAndUpdateTimePair.first;
-              mostRecentUpdateTime = station->m_rssiAndUpdateTimePair.second;
-            }
-        }
-    }
-  NS_ASSERT (mostRecentUpdateTime.IsStrictlyPositive ());
+  auto stationIt = m_stations.find (address);
+  NS_ASSERT_MSG (stationIt != m_stations.end(), "Address: " << address << " not found");
+  auto station = stationIt->second;
+  auto rssi = station->m_rssiAndUpdateTimePair.first;
+  auto ts = station->m_rssiAndUpdateTimePair.second;
+  NS_ASSERT_MSG (ts.IsStrictlyPositive(), "address: " << address << " ts:" << ts);
   return rssi;
 }
 
@@ -1227,17 +1231,18 @@
 WifiRemoteStationManager::LookupState (Mac48Address address) const
 {
   NS_LOG_FUNCTION (this << address);
-  for (StationStates::const_iterator i = m_states.begin (); i != m_states.end (); i++)
+  auto stateIt = m_states.find (address);
+
+  if (stateIt != m_states.end ())
     {
-      if ((*i)->m_address == address)
-        {
-          NS_LOG_DEBUG ("WifiRemoteStationManager::LookupState returning existing state");
-          return (*i);
-        }
+      NS_LOG_DEBUG ("WifiRemoteStationManager::LookupState returning existing state");
+      return stateIt->second;
     }
+
   WifiRemoteStationState *state = new WifiRemoteStationState ();
   state->m_state = WifiRemoteStationState::BRAND_NEW;
   state->m_address = address;
+  state->m_aid = 0;
   state->m_operationalRateSet.push_back (GetDefaultMode ());
   state->m_operationalMcsSet.push_back (GetDefaultMcs ());
   state->m_dsssSupported = false;
@@ -1251,7 +1256,7 @@
   state->m_ness = 0;
   state->m_aggregation = false;
   state->m_qosSupported = false;
-  const_cast<WifiRemoteStationManager *> (this)->m_states.push_back (state);
+  const_cast<WifiRemoteStationManager *> (this)->m_states.insert ({address, state});
   NS_LOG_DEBUG ("WifiRemoteStationManager::LookupState returning new state");
   return state;
 }
@@ -1260,23 +1265,30 @@
 WifiRemoteStationManager::Lookup (Mac48Address address) const
 {
   NS_LOG_FUNCTION (this << address);
-  for (Stations::const_iterator i = m_stations.begin (); i != m_stations.end (); i++)
+  auto stationIt = m_stations.find (address);
+
+  if (stationIt != m_stations.end ())
     {
-      if ((*i)->m_state->m_address == address)
-        {
-          return (*i);
-        }
+      return stationIt->second;
     }
+
   WifiRemoteStationState *state = LookupState (address);
 
   WifiRemoteStation *station = DoCreateStation ();
   station->m_state = state;
   station->m_rssiAndUpdateTimePair = std::make_pair (0, Seconds (0));
-  const_cast<WifiRemoteStationManager *> (this)->m_stations.push_back (station);
+  const_cast<WifiRemoteStationManager *> (this)->m_stations.insert ({address, station});
   return station;
 }
 
 void
+WifiRemoteStationManager::SetAssociationId (Mac48Address remoteAddress, uint16_t aid)
+{
+  NS_LOG_FUNCTION (this << remoteAddress << aid);
+  LookupState (remoteAddress)->m_aid = aid;
+}
+
+void
 WifiRemoteStationManager::SetQosSupport (Mac48Address from, bool qosSupported)
 {
   NS_LOG_FUNCTION (this << from << qosSupported);
@@ -1458,14 +1470,14 @@
 WifiRemoteStationManager::Reset (void)
 {
   NS_LOG_FUNCTION (this);
-  for (StationStates::const_iterator i = m_states.begin (); i != m_states.end (); i++)
+  for (auto& state : m_states)
     {
-      delete (*i);
+      delete (state.second);
     }
   m_states.clear ();
-  for (Stations::const_iterator i = m_stations.begin (); i != m_stations.end (); i++)
+  for (auto& state: m_stations)
     {
-      delete (*i);
+      delete (state.second);
     }
   m_stations.clear ();
   m_bssBasicRateSet.clear ();
